clc; clear; close all;

num_scenarios = 100;
max_robots = 10;
max_tasks = 100;

%% Run it here.
% results = cell(max_robots, max_tasks);
% for num_robots = 2:max_robots
%     disp(['Num robots ' num2str(num_robots)]);
%     for num_tasks = 1:max_tasks
%         disp([' -Num tasks ' num2str(num_tasks)]);
%         results{num_robots,num_tasks} = zeros(num_scenarios,2);
%         for scenario_num = 1:num_scenarios
% %             disp(['Scenario ' num2str(scenario_num)]);
%             [res, res2opt] = performAuction( scenario_num, num_robots, 0, num_tasks, 1 );
%             results{num_robots,num_tasks}(scenario_num,:) = [res res2opt];
%         end
%     end
% end
% 
% disp('COMPLETE');

%% Save it here.
% save('resultslb3','results');
% save('resultslcb3','results');
% save('resultslcbr3','results');

%% Load it here
load('resultslcb3');
resultslcb = results;
load('resultslb3');
resultslb = results;
% load('resultslcbr3');
% resultslb = results;
% clear results;

%% Process improvement
matl = zeros(max_robots, max_tasks);
for i=2:max_robots
    for j=1:max_tasks
        mat_res(i,j) = 100.*mean( 1 - resultslcb{i,j}(:,1) ./ resultslb{i,j}(:,1) );
    end
end


figure()
pcolor(mat_res);
xlabel('num tasks');
ylabel('num robots');
title('LCB improvement over LB (%)');

colormap('hot');
colorbar();
caxis([0 20])

%% Process 2 opt improvement for each.
matl = zeros(max_robots, max_tasks);
for i=2:max_robots
    for j=1:max_tasks
        mat_res(i,j) = 100.*mean( 1 - resultslcb{i,j}(:,2) ./ resultslcb{i,j}(:,1) );
    end
end

figure()
pcolor(mat_res);
xlabel('num tasks');
ylabel('num robots');
title('2-opt improvement for LCB (%)');

colormap('hot');
colorbar();
caxis([0 10])

%% Process 2 opt improvement for each.
matl = zeros(max_robots, max_tasks);
for i=2:max_robots
    for j=1:max_tasks
        mat_res(i,j) = 100.*mean( 1 - resultslb{i,j}(:,2) ./ resultslb{i,j}(:,1) );
    end
end

figure()
pcolor(mat_res);
xlabel('num tasks');
ylabel('num robots');
title('2-opt improvement for LB (%)');

colormap('hot');
colorbar();
caxis([0 10])



% 
% % Find examples where LB was greater than LCB
% for i=2:max_robots
%     for j=1:max_tasks
%         for k=1:num_scenarios
%             if resultslcb{i,j}(k,1) > resultslb{i,j}(k,1)
%                disp(num2str(i));
%                disp(num2str(j));
%                disp(num2str(k));
%                disp('moo');
%             end
%         end
%     end
% end
