%% Nick Sullivan 2017, The University of Adelaide
% Automates the randomly generated data (make sure performGA and
% performAuction have the correct options).

function [ ] = runPhoenix2( phoenix_run_id_str )
% time_start = cputime;
tic
disp('Starting (0)');

% Perform tests.  
% [0001-0200] = 10T, 3R, 0.0exp
% [0201-0400] = 10T, 3R, 0.2exp
% [0401-0600] = 10T, 3R, 0.4exp
% [0601-0800] = 10T, 3R, 0.6exp
% [0801-1000] = 10T, 3R, 0.8exp
% [1001-1200] = 10T, 3R, 1.0exp

% [1201-1400] = 10T, 5R, 0.0exp
% [1401-1600] = 10T, 5R, 0.2exp
% [1601-1800] = 10T, 5R, 0.4exp
% [1801-2000] = 10T, 5R, 0.6exp
% [2001-2200] = 10T, 5R, 0.8exp
% [2201-2400] = 10T, 5R, 1.0exp

% [2401-2600] = 10T, 10R, 0.0exp
% [2601-2800] = 10T, 10R, 0.2exp
% [2801-3000] = 10T, 10R, 0.4exp
% [3001-3200] = 10T, 10R, 0.6exp
% [3201-3400] = 10T, 10R, 0.8exp
% [3401-3600] = 10T, 10R, 1.0exp

% [3601-3800] = 20T, 3R, 0.0exp
% [3801-4000] = 20T, 3R, 0.2exp
% [4001-4200] = 20T, 3R, 0.4exp
% [4201-4400] = 20T, 3R, 0.6exp
% [4401-4600] = 20T, 3R, 0.8exp
% [4601-4800] = 20T, 3R, 1.0exp

% [4801-5000] = 20T, 5R, 0.0exp
% [5001-5200] = 20T, 5R, 0.2exp
% [5201-5400] = 20T, 5R, 0.4exp
% [5401-5600] = 20T, 5R, 0.6exp
% [5601-5800] = 20T, 5R, 0.8exp
% [5801-6000] = 20T, 5R, 1.0exp

% [6001-6200] = 20T, 10R, 0.0exp
% [6201-6400] = 20T, 10R, 0.2exp
% [6401-6600] = 20T, 10R, 0.4exp
% [6601-6800] = 20T, 10R, 0.6exp
% [6801-7000] = 20T, 10R, 0.8exp
% [7001-7200] = 20T, 10R, 1.0exp

% [7201-7400] = 30T, 3R, 0.0exp
% [7401-7600] = 30T, 3R, 0.2exp
% [7601-7800] = 30T, 3R, 0.4exp
% [7801-8000] = 30T, 3R, 0.6exp
% [8001-8200] = 30T, 3R, 0.8exp
% [8201-8400] = 30T, 3R, 1.0exp

% [8401-8600] = 30T, 5R, 0.0exp
% [8601-8800] = 30T, 5R, 0.2exp
% [8801-9000] = 30T, 5R, 0.4exp
% [9001-9200] = 30T, 5R, 0.6exp
% [9201-9400] = 30T, 5R, 0.8exp
% [9401-9600] = 30T, 5R, 1.0exp

% [9601-9800] = 30T, 10R, 0.0exp
% [9801-10000] = 30T, 10R, 0.2exp
% [10001-10200] = 30T, 10R, 0.4exp
% [10201-10400] = 30T, 10R, 0.6exp
% [10401-10600] = 30T, 10R, 0.8exp
% [10601-10800] = 30T, 10R, 1.0exp


 
id = str2num(phoenix_run_id_str);

% temp move for 30T (do 1 to 3600)
%id = id + 7200

if id <= 3600
    num_tasks_per_type = 10;
    num_iterations = 5e4;
    id = id - 0;
elseif id <= 7200
    num_tasks_per_type = 20;
    num_iterations = 3e5;
    id = id - 3600;
elseif id <= 10800
    num_tasks_per_type = 30;
    num_iterations = 5e5;
    id = id - 7200;
else
    disp('error, num too high');
    
end

if id <= 1200
    num_robots = 3;
    id = id - 0;
elseif id <= 2400
    num_robots = 5;
    id = id - 1200;
elseif id <= 3600
    num_robots = 10;
    id = id - 2400;
end

if id <= 200
    exp = 0.0;
    id = id - 0;
elseif id <= 400
    exp = 0.2;
    id = id - 200;
elseif id <= 600
    exp = 0.4;
    id = id - 400;
elseif id <= 800
    exp = 0.6;
    id = id - 600;
elseif id <= 1000
    id = id - 800;
    exp = 0.8;
elseif id <= 1200
    exp = 1.0;
    id = id - 1000;
end

scenario = id;


disp('Running Auction');
[result, result_with_2_opt] = performAuction(scenario, num_robots, exp, num_tasks_per_type);
filename = sprintf('ResultAuction%03s-%02s-%02s-%02s.txt',num2str(scenario), num2str(num_tasks_per_type), num2str(num_robots), num2str(exp*10));

% disp('Running Optimal');
% [result, result_with_2_opt] = performOptimal(scenario);
% filename = sprintf('ResultOptimal%03s.txt',num2str(scenario));

% disp('Running GA');
% [result, result_with_2_opt] = performGA(scenario, num_robots, exp, num_tasks_per_type, num_iterations);
% filename = sprintf('ResultGA%03s-%02s-%02s-%02s.txt',num2str(scenario), num2str(num_tasks_per_type), num2str(num_robots), num2str(exp*10));
disp(filename);

computation_time = toc;
disp(['Best cost: ' num2str(result)]);
disp(['2-opt best cost is: ' num2str(result_with_2_opt)]);
disp(['Computation time: ' num2str(computation_time)]);

% Write results.
fid=fopen(filename,'w');
fprintf(fid, [num2str(result) ' ' num2str(result_with_2_opt) ' ' num2str(computation_time) '\r\n']);
fclose(fid);

disp(['Finished! (' num2str(computation_time) ')']);
end