%% Nick Sullivan 2017, The University of Adelaide
% Automates the TSPLIB data (make sure performGA and performAuction have 
% the correct options).

function [ ] = runPhoenix3( phoenix_run_id_str )
% time_start = cputime;
tic
disp('Starting (0)');

% Perform tests (all should have the same exp). The scenario num only affects RNG values.  
% [0001-0050] = Pr76, 3To, 3Ro, 4Ra
% [0051-0100] = Pr76, 3To, 3Ro, 8Ra
% [0101-0150] = Pr76, 3To, 5Ro, 4Ra
% [0151-0200] = Pr76, 3To, 5Ro, 8Ra
% [0201-0250] = Pr76, 3To,10Ro, 4Ra
% [0251-0300] = Pr76, 3To,10Ro, 8Ra
% [0301-0350] = Pr76, 5To, 3Ro, 4Ra
% [0351-0400] = Pr76, 5To, 3Ro, 8Ra
% [0401-0450] = Pr76, 5To, 5Ro, 4Ra
% [0451-0500] = Pr76, 5To, 5Ro, 8Ra
% [0501-0550] = Pr76, 5To,10Ro, 4Ra
% [0551-0600] = Pr76, 5To,10Ro, 8Ra
% [0601-0650] = Pr76, 9To, 3Ro, 4Ra
% [0651-0700] = Pr76, 9To, 3Ro, 8Ra
% [0701-0750] = Pr76, 9To, 5Ro, 4Ra
% [0751-0800] = Pr76, 9To, 5Ro, 8Ra
% [0801-0850] = Pr76, 9To,10Ro, 4Ra
% [0851-0900] = Pr76, 9To,10Ro, 8Ra

% [0901-0950] = Pr152, 3To, 3Ro, 4Ra
% [0951-1000] = Pr152, 3To, 3Ro, 8Ra
% [1001-1050] = Pr152, 3To, 5Ro, 4Ra
% [1051-1100] = Pr152, 3To, 5Ro, 8Ra
% [1101-1150] = Pr152, 3To,10Ro, 4Ra
% [1151-1200] = Pr152, 3To,10Ro, 8Ra
% [1201-1250] = Pr152, 5To, 3Ro, 4Ra
% [1251-1300] = Pr152, 5To, 3Ro, 8Ra
% [1301-1350] = Pr152, 5To, 5Ro, 4Ra
% [1351-1400] = Pr152, 5To, 5Ro, 8Ra
% [1401-1450] = Pr152, 5To,10Ro, 4Ra
% [1451-1500] = Pr152, 5To,10Ro, 8Ra
% [1501-1550] = Pr152, 9To, 3Ro, 4Ra
% [1551-1600] = Pr152, 9To, 3Ro, 8Ra
% [1601-1650] = Pr152, 9To, 5Ro, 4Ra
% [1651-1700] = Pr152, 9To, 5Ro, 8Ra
% [1701-1750] = Pr152, 9To,10Ro, 4Ra
% [1751-1800] = Pr152, 9To,10Ro, 8Ra

% [1801-1850] = Pr226, 3To, 3Ro, 4Ra
% [1851-1900] = Pr226, 3To, 3Ro, 8Ra
% [1901-1950] = Pr226, 3To, 5Ro, 4Ra
% [1951-2000] = Pr226, 3To, 5Ro, 8Ra
% [2001-2050] = Pr226, 3To,10Ro, 4Ra
% [2051-2100] = Pr226, 3To,10Ro, 8Ra
% [2101-2150] = Pr226, 5To, 3Ro, 4Ra
% [2151-2200] = Pr226, 5To, 3Ro, 8Ra
% [2201-2250] = Pr226, 5To, 5Ro, 4Ra
% [2251-2300] = Pr226, 5To, 5Ro, 8Ra
% [2301-2350] = Pr226, 5To,10Ro, 4Ra
% [2351-2400] = Pr226, 5To,10Ro, 8Ra
% [2401-2450] = Pr226, 9To, 3Ro, 4Ra
% [2451-2500] = Pr226, 9To, 3Ro, 8Ra
% [2501-2550] = Pr226, 9To, 5Ro, 4Ra
% [2551-2600] = Pr226, 9To, 5Ro, 8Ra
% [2601-2650] = Pr226, 9To,10Ro, 4Ra
% [2651-2700] = Pr226, 9To,10Ro, 8Ra

id = str2num(phoenix_run_id_str);
% only do the first if we want
% id = 1 + (id - 1) * 50

if id <= 900
    tsplib_name = 'pr76';
    num_iterations = 5e4;
    id = id - 0;
elseif id <= 1800
    tsplib_name = 'pr152';
    num_iterations = 3e5;
    id = id - 900;
elseif id <= 2700
    tsplib_name = 'pr226';
    num_iterations = 5e5;
    id = id - 1800;
else
    disp('error, num too high');
end

if id <= 300
    num_tools = 3;
    id = id - 0;
elseif id <= 600
    num_tools = 5;
    id = id - 300;
elseif id <= 900
    num_tools = 9;
    id = id - 600;
end

if id <= 100
    num_robots = 3;
    id = id - 0;
elseif id <= 200
    num_robots = 5;
    id = id - 100;
elseif id <= 300
    num_robots = 10;
    id = id - 200;
end

if id <= 50
    num_racks = 4;
    id = id - 0;
elseif id <= 100
    num_racks = 8;
    id = id - 50;
end
scenario = id;

exp = 0.2; % THIS DOES NOTHING, ALTER IN LOADSTATEFROMTSPLIB
num_tasks_per_type = 1; % unused


% disp('Running Auction');
% [result, result_with_2_opt] = performAuction(scenario, num_robots, exp, num_tasks_per_type, num_tools, num_racks,tsplib_name);
% filename = sprintf('ResultAuction-%s-%03s-%02s-%02s-%02s.txt',tsplib_name, num2str(scenario), num2str(num_tools), num2str(num_robots), num2str(num_racks));


% disp('Running Optimal');
% [result, result_with_2_opt] = performOptimal(scenario);
% filename = sprintf('ResultOptimal-%03s.txt',num2str(scenario));

disp('Running GA');
[result, result_with_2_opt] = performGA(scenario, num_robots, exp, num_tasks_per_type, num_iterations, num_tools, num_racks,tsplib_name);
filename = sprintf('ResultGA-%s-%03s-%02s-%02s-%02s.txt',tsplib_name, num2str(scenario), num2str(num_tools), num2str(num_robots), num2str(num_racks));

disp(filename);

computation_time = toc;
disp(['Best cost: ' num2str(result)]);
disp(['2-opt best cost is: ' num2str(result_with_2_opt)]);
disp(['Computation time: ' num2str(computation_time)]);

% Write results.
% fid=fopen(filename,'w');
% fprintf(fid, [num2str(result) ' ' num2str(result_with_2_opt) ' ' num2str(computation_time) '\r\n']);
% fclose(fid);

disp(['Finished! (' num2str(computation_time) ')']);
end